
//客户端唯一编码
let ocn = null;
//是否加载完成？
let hasLoaded = 0;

$(document).ready(function () {

    ocn = generateOcid();

    //配送方式的点击响应事件
    $('.detail-params.delivery').click(function () {

        let dataId = $(this).attr('data-id');
        if(dataId == '4' || dataId == '5'){
            $('#address').removeAttr('readonly');
            $('#address').val('');
        }else{
            $('#address').attr('readonly','readonly');
        }

        //取消其兄弟节点的active
        let siblings = $(this).siblings();
        for(let ele of siblings){
            $(ele).removeClass('active');
        }
        //增加其自身的active
        $(this).addClass('active');

        let paymethod = $('.detail-params.delivery.active').attr('data-id');
        if(paymethod == '1' || paymethod == '2' || paymethod == '3'){
            $('.shop-selector').attr('style','display: block; width: 96%;');
            queryShopType();
        }else{
            $('.shop-selector').removeAttr('style');
        }

        if(hasLoaded == 1){
            addUserOpt('delivery', $(this).text());
        }
    });

    //默认选中第一个配送方式
    $('.detail-params.delivery:first-child').click();

    if(saleType == '1'){
        //生成单品SKU
        generateSingleSKU();

        //产品属性的点击响应事件
        $('.attr-item').click(function () {
            //取消其兄弟节点的active
            let siblings = $(this).siblings();
            for(let ele of siblings){
                $(ele).attr('class', 'attr-item');
            }
            //增加其自身的active
            $(this).attr('class', 'attr-item active');
            //获取对应的价格
            getSinglePrice();

            if(hasLoaded == 1){
                addUserOpt('attrItem', $(this).text());
            }
        })

        //默认点击生成各属性第一个属性项
        $('.attr-items>.attr-item:first-child').click();

    }else{
        if(saleType == '2'){

            //套餐的点击响应事件
            $('.goods_package').click(function () {
                let siblings = $(this).siblings();
                for(let ele of siblings){
                    $(ele).attr('class', 'goods_package');
                }
                $(this).attr('class', 'goods_package active');

                generatePackageItem();

                getPackagePrice();

                if(hasLoaded == 1){
                    addUserOpt('package', $(this).text());
                }
            });

            let dc = $('.goods_package[data-dc="1"]');
            if(dc.length > 0){
                $(dc[0]).click();
            }else{
                //默认选中第一个套餐
                $('.goods_package:first-child').click();
            }

        }
    }

    if(levelNum > 1){
        queryProvince($('select.area').val());
    }

    calShipAndOrderPrice();

    hasLoaded = 1;
});

/**
 * 生成单品的SKU
 **/
let generateSingleSKU = function () {
    let htmlStr = '';
    for (let attr of productAttrs){
        htmlStr = htmlStr +
            '<div>\n' +
            '<p class="attr" data-id="'+attr.id+'">*'+attr.name+'</p>\n' +
            '<div class="layui-input-block attr-items">\n' ;

        let attrList = [];
        //将当前产品属性下属的产品属性项加入
        for(let item of productAttrItems){
            if(item.attrId == attr.id){
                attrList.push(item);
            }
        }
        //如果所有的属性项均有图片，则显示
        let showImg = true;
        for(let item of attrList){
            if( !(('img') in item) ){
                showImg = false;
                break;
            }else{
                if (item.img == null || item.img.trim().length == 0){
                    showImg = false;
                    break;
                }
            }
        }
        for(let item of attrList){
            if(showImg){
                htmlStr = htmlStr +
                    '<div class="attr-item" data-id="'+item.id+'" data-pid="'+attr.id+'">\n'+
                    '    <img src="'+item.img+'">\n'+
                    '    <div><input type="radio" name="'+attr.name+'" value="'+item.name+'">'+item.name+'</div>\n'+
                    '</div>\n';
            }else{
                htmlStr = htmlStr +
                    '<div class="attr-item" data-id="'+item.id+'" data-pid="'+attr.id+'">\n'+
                    '    <div><input type="radio" name="'+attr.name+'" value="'+item.name+'">'+item.name+'</div>\n'+
                    '</div>\n';
            }
        }
        htmlStr = htmlStr +
            '</div>\n' +
            '</div>\n'

        $('#single-attrs').html(htmlStr);
    }
}

/**
 * 生成套餐项
 * */
let generatePackageItem = function(){
    let hasGen = 0;
    //查询当前套餐的套餐项名称
    let packageId = $('.goods_package.active').attr('data-id');
    //从packItems中找到对应的套餐项
    let htmlStr = '';
    for(let packItem of packItems){
        if(packItem.packageId == packageId){

            htmlStr = htmlStr +
                '<div class="layui-colla-item" data-id="'+packItem.id+'">\n' +
                '  <h2 class="layui-colla-title">'+packItem.name+'</h2>\n' +
                '  <div class="layui-colla-content layui-show">\n';

            let productId = packItem.productId;
            //找到对应产品的信息的属性、属性值
            for (let attr of productAttrs){
                if (attr.productId == productId){
                    htmlStr = htmlStr +
                        '    <div>\n' +
                        '      <p class="attr" data-id="'+attr.id+'">*'+attr.name+'</p>\n' +
                        '      <div class="layui-input-block attr-items">\n' ;

                    let attrList = [];
                    //将当前产品属性下属的产品属性项加入
                    for(let item of productAttrItems){
                        if(item.attrId == attr.id){
                            attrList.push(item);
                        }
                    }
                    //如果所有的属性项均有图片，则显示
                    let showImg = true;
                    for(let item of attrList){
                        if( !(('img') in item) ){
                            showImg = false;
                            break;
                        }else{
                            if (item.img == null || item.img.trim().length == 0){
                                showImg = false;
                                break;
                            }
                        }
                    }
                    for(let item of attrList){
                        if(showImg){
                            if(packItem.num != '1'){
                                htmlStr = htmlStr +
                                    '<div class="attr-item" data-iid="'+packItem.id+'" data-id="'+item.id+'" data-pid="'+attr.id+'">\n'+
                                    '    <img src="'+item.img+'">\n'+
                                    '    <div><input type="radio" name="'+attr.name+'" value="'+item.name+'">'+item.name+'&nbsp;&nbsp;x&nbsp;'+packItem.num+'</div>\n'+
                                    '</div>\n';
                            }else {
                                htmlStr = htmlStr +
                                    '<div class="attr-item" data-iid="'+packItem.id+'" data-id="'+item.id+'" data-pid="'+attr.id+'">\n'+
                                    '    <img src="'+item.img+'">\n'+
                                    '    <div><input type="radio" name="'+attr.name+'" value="'+item.name+'">'+item.name+'</div>\n'+
                                    '</div>\n';
                            }
                        }else{
                            if(packItem.num != '1'){
                                htmlStr = htmlStr +
                                    '<div class="attr-item" data-iid="'+packItem.id+'" data-id="'+item.id+'" data-pid="'+attr.id+'">\n'+
                                    '    <div><input type="radio" name="'+attr.name+'" value="'+item.name+'">'+item.name+'&nbsp;&nbsp;x&nbsp;'+packItem.num+'</div>\n'+
                                    '</div>\n';
                            }else {
                                htmlStr = htmlStr +
                                    '<div class="attr-item" data-iid="'+packItem.id+'" data-id="'+item.id+'" data-pid="'+attr.id+'">\n'+
                                    '    <div><input type="radio" name="'+attr.name+'" value="'+item.name+'">'+item.name+'</div>\n'+
                                    '</div>\n';
                            }
                        }
                    }

                    htmlStr = htmlStr +
                        '        </div>\n' +
                        '       </div>\n' ;
                }
            }

            htmlStr = htmlStr +
                '  </div>\n' +
                '</div>';
        }
    }
    $('.package-items>.layui-collapse').html(htmlStr);

    //产品属性的点击响应事件
    $('.attr-item').click(function () {
        //取消其兄弟节点的active
        let siblings = $(this).siblings();
        for(let ele of siblings){
            $(ele).attr('class', 'attr-item');
        }
        //增加其自身的active
        $(this).attr('class', 'attr-item active');

        if(hasLoaded == 1 && hasGen == 1){
            addUserOpt('attrItem', $(this).text());
        }
    })

    //默认点击生成各属性第一个属性项
    $('.attr-items>.attr-item:first-child').click();

    hasGen = 1;
}

/**
 * 获取单品的SKU价格
 **/
let getSinglePrice = function(){
    //获取当前选中的各信息
    let chooseEles = $('.attr-item.active');
    let attr = {};
    for(let ele of chooseEles){
        let ipt = $(ele).find('input');
        attr[$(ipt).attr('name')] = $(ipt).val();
    }
    $('#showprice').text('');
    $('#product-price').text('');
    for(let sku of productSkus){
        let skuAttr = JSON.parse(sku.attrList);
        if(compareAttr(attr, skuAttr)){
            let price = sku.price;
            $('#showprice').text(formatDecimal(price));
            $('#product-price').text(formatDecimal(price));
            break;
        }
    }
    calShipAndOrderPrice();
}

/***
 * 获取套餐的价格
 */
let getPackagePrice = function(){
    let packageId = $('.goods_package.active').attr('data-id');
    for(let pack of packs){
        if (pack.id == packageId){
            let price = pack.price;
            $('#showprice').text(formatDecimal(price));
            $('#product-price').text(formatDecimal(price));
            packShip = pack.shipCost;
            break;
        }
    }
    calShipAndOrderPrice();
}

/**
 * 比较两个SKU是否相等
 */
let compareAttr = function(attr1, attr2){
    for (let key in attr2){
        if (!(key in attr1) || attr1[key] != attr2[key]){
            return false;
        }
    }
    return true;
}

/**
 * 查询省份信息
 **/
let queryProvince = function (id) {
    queryArea(id, $('select.province'));
}

$('select.province').change(function () {
    if(levelNum == 3) {
        queryCity($(this).val());
    }
    calShipAndOrderPrice();

    addUserOpt('province', $(this).find("option:selected").text());
})

$('select.city').change(function () {
    calShipAndOrderPrice();

    addUserOpt('city', $(this).find("option:selected").text());
    //泰国菲律宾的时候，才执行
    if(areaId != 6 && areaId != 9 ){
        return ;
    }
    if(levelNum == 3) {
        queryCounty($(this).val());
    }

})

let queryCity = function (id) {
    queryArea(id, $('select.city'));
}

let queryCounty = function (id) {
    queryArea(id, $('select.county'));
}

let queryArea = function (id, selector) {
    if(id != null){
        $.ajax({
            url : 'area/'+id,
            method: 'GET',
            success:function (res) {
                res.data;
                let htmlStr = '<option value="">'+keya83318c3+'</option>';
                for(let area of res.data){
                    htmlStr = htmlStr + '<option value="'+area.id+'" data-remote="'+area.isRemote+'">'+area.localName+'</option>';
                }
                $(selector).html(htmlStr);
            }
        })
    }
}

$('select.city').change(function () {
    queryShopType();
    calShipAndOrderPrice();
    addUserOpt('city', $(this).find("option:selected").text());
})

$('select.shop-selector').change(function () {
    $('#address').val($(this).find("option:selected").attr('data-address'));
    let value = $('#address').val();
    if(value.trim() != ''){
        addUserOpt('address', value);
    }
})

let queryShopType = function(){
    let deliveryMethod = $('.detail-params.delivery.active').attr('data-id');
    if(deliveryMethod == '1' || deliveryMethod == '2' || deliveryMethod == '3'){
        let sp = {};
        sp.shopType = deliveryMethod;
        sp.area = $('.detail-region.area').val();
        sp.province = $('.detail-region.province').val();
        sp.city = $('.detail-region.city').val();
        if(sp.area != null && sp.province != null && sp.city != null){
            $.ajax({
                url :'shop',
                type :'POST',
                data : JSON.stringify(sp),
                contentType : 'application/json',
                dataType :'json',
                success:function(res){
                    let shops = res.data;
                    let htmlStr = '<option value="">請選擇店鋪</option>';
                    for(let shop of shops){
                        if (areaId == 2){
                            htmlStr = htmlStr + '<option value="'+shop.shopId+'" data-address="'+shop.address+'，店鋪名：'+shop.name +'，店鋪號：'+shop.shopNumber+'">' + shop.name + '--' + shop.address+'</option>';
                        }else{
                            htmlStr = htmlStr + '<option value="'+shop.shopId+'" data-address="'+shop.address+'">' + shop.address+'</option>';
                        }
                    }
                    $('.shop-selector').html(htmlStr);
                }
            })
        }
    }
}

/**
 * 提交订单
 **/
$('#submitBtn').click(function () {
    submitOrder();
});

let submitOrder = function () {
    let reqOrder = {};
    reqOrder.ocn = ocn;
    reqOrder.pageUrl = window.location.href;
    reqOrder.suffix =  suffix;
    reqOrder.currencySymbol = currencySymbol;
    reqOrder.saleType = saleType;
    reqOrder.productType = productType;
    if(reqOrder.saleType == '1'){
        //获取单品选中的sku属性
        let attrEles = $('.attr-item.active');
        let sku = [];
        for(let attrEle of attrEles){
            let attr = $(attrEle).attr('data-pid');
            let attrItem = $(attrEle).attr('data-id');
            let obj = {};
            obj.attrId = attr;
            obj.attrItemId = attrItem;
            sku.push(obj);
        }
        reqOrder.content = JSON.stringify(sku);
    }else{
        let packageId = $('.goods_package.active').attr('data-id');
        let items = [];
        let itemEles = $('.package-items>.layui-collapse>.layui-colla-item');
        for (let itemEle of itemEles){
            let item = {};
            item.itemId = $(itemEle).attr('data-id');
            item.attrs = [];
            //获取选中的sku属性
            let attrEles = $(itemEle).find('.attr-item.active');
            for(let attrEle of attrEles){
                let attrId = $(attrEle).attr('data-pid');
                let attrItemId = $(attrEle).attr('data-id');
                let attr = {};
                attr.attrId = attrId;
                attr.attrItemId = attrItemId;
                item.attrs.push(attr);
            }
            items.push(item);
        }
        let co = {};
        co.packageId = packageId;
        co.items = items;

        reqOrder.content = JSON.stringify(co);
    }
    reqOrder.price = $('#product-price').text();
    reqOrder.shipCost = $('#ship-cost').text();
    reqOrder.totalPrice = $('#order-price').text();
    reqOrder.username = $('#username').val();
    reqOrder.phone = $('#phone').val();
    reqOrder.delivery = $('.detail-params.delivery.active').attr('data-id');

    if(levelNum == 3){
        reqOrder.area = $('.detail-region.area option:selected').text();
        reqOrder.province = $('.detail-region.province option:selected').text();
        reqOrder.city = $('.detail-region.city option:selected').text();
        //泰国区
        if(areaId=='6' || areaId=='9'){
            reqOrder.county = $('.detail-region.county option:selected').text();
        }
        let hasShop = $('.shop-selector').attr('style');
        if(hasShop != null){
            reqOrder.shopId =  $('.shop-selector').val();
        }
    }else{
        if(levelNum == 2){
            reqOrder.area = $('.detail-region.area option:selected').text();
            reqOrder.province = $('.detail-region.province option:selected').text();
        }else{
            reqOrder.area = $('.detail-region.area option:selected').text();
        }
    }
    reqOrder.address = $('#address').val();
    reqOrder.message = $('#message').val();
    reqOrder.email = $('#email').val();
    reqOrder.zipCode = $('#zipCode').val();

    if(checkOrderLegal(reqOrder)){
        $('.index_addBox').addClass('show');
        //加密
        let request = encryptData(reqOrder)
        $.ajax({
            url :'submit',
            type :'POST',
            data : JSON.stringify(request),
            contentType : 'application/json',
            dataType :'json',
            success:function(res){
                res = decryptData(res)
                if(res.code == 200){
                    addUserOpt('submit', 'success');
                    try{
                        ttq.track('CompletePayment', {
                            contents: [
                                {
                                    // content_id: '301',
                                    // content_name: 'dress',
                                    quantity: 1,
                                    price: 8,
                                }],
                            content_type: 'product',
                            value: 60,
                            currency: 'USD',
                        });
                    }catch (err){

                    }
                    try{

                        fbq('track', 'Purchase', {currency: "USD", value: '60.00'});

                    }catch (err) {

                    }

                    setTimeout(function () {
                        $('.index_addBox').removeClass('show');
                        window.location = '/query?no='+res.data.no+'&lang='+res.data.lang+'&flag=success';
                    }, 2000)


                }else{
                    alert(res.msg);
                    $('.index_addBox').removeClass('show');
                }
            },
            error:function () {
                alert("Sorry, something wrong happens!");
                $('.index_addBox').removeClass('show');
            }
        })
    }
    return true;
}

let checkOrderLegal = function(reqOrder){
    if (isEmpty(reqOrder.username)){
        alert(keybd85e0c1);
        return false;
    }
    if (isEmpty(reqOrder.phone)){
        alert(key70728632);
        return false;
    }else{
        if (areaId == 2){
            let regex = /^0\d{9}$/ ;
            if( !regex.test(reqOrder.phone) ){
                alert(key04c6a40e);
                return false;
            }
        }else {
            if (areaId == 3 || areaId == 4|| areaId == 8) {
                let regex = /^\d{8}$/ ;
                if( !regex.test(reqOrder.phone) ){
                    alert(keyc9196506);
                    return false;
                }
            }
        }
    }
    if (isEmpty(reqOrder.delivery)){
        alert(key96af0fb1);
        return false;
    }
    if (isEmpty(reqOrder.area)){
        alert(key9a28c19b);
        return false;
    }
    if ('province' in reqOrder && (isEmpty(reqOrder.province) || reqOrder.province == '選擇地區')){
        console.log(reqOrder.province)
        alert(key9a28c19b);
        return false;
    }
    if ('city' in reqOrder && (isEmpty(reqOrder.city) || reqOrder.city == '選擇地區')){
        console.log(reqOrder.city)
        alert(key9a28c19b);
        return false;
    }
    if('shopId' in reqOrder && isEmpty(reqOrder.shopId)){
        alert(key33014b13);
        return false;
    }
    if (isEmpty(reqOrder.address)){
        alert(key6640d914);
        return false;
    }
    if (needZipCode=='1'){
        if (isEmpty(reqOrder.zipCode)){
            alert(key0055f748);
            return false;
        }else{
            //新加坡
            if (areaId == 4){
                let regex = /^\d{6}$/ ;
                if( !regex.test(reqOrder.zipCode) ){
                    alert(keyf5241930);
                    return false;
                }
            }
            //马来
            if (areaId == 5) {
                let regex =  /^\d{5}$/ ;
                if( !regex.test(reqOrder.zipCode) ){
                    alert(key483f1733);
                    return false;
                }
            }
            //泰国
            if(areaId == 6){
                let regex =  /^\d{5}$/ ;
                if( !regex.test(reqOrder.zipCode) ){
                    alert(keya0a99c1f);
                    return false;
                }
            }
        }
    }
    return true;
}

let generateOcid = function () {
    let now = new Date();
    return now.getTime();
}

let calShipAndOrderPrice = function () {
    //判断是否偏远地区
    let remote = false;
    if ($('.detail-region.area').length == 1){
        if ( $('.detail-region.area').find("option:selected").attr('data-remote') == '1' ){
            remote = true;
        }
    }
    if ($('.detail-region.province').length == 1){
        if ( $('.detail-region.province').find("option:selected").attr('data-remote') == '1' ){
            remote = true;
        }
    }
    if ($('.detail-region.city').length == 1){
        if ( $('.detail-region.city').find("option:selected").attr('data-remote') == '1' ){
            remote = true;
        }
    }
    if ($('.detail-region.county').length == 1){
        if ( $('.detail-region.county').find("option:selected").attr('data-remote') == '1' ){
            remote = true;
        }
    }

    let productPrice = $('#product-price').text();
    let shipCost = null;

    if (remote){
        //运费设置为偏远地区运费
        shipCost = remoteShip;
    }else{
        //运费设置为0或套餐运费
        if(saleType == 1){
            shipCost = 0;
        }else {
            shipCost = packShip;
        }
    }

    $('#ship-cost').text(formatDecimal(shipCost));

    //计算订单总价
    let orderPrice = addNums(productPrice, shipCost);
    $('#order-price').text(formatDecimal(orderPrice));
}

